var W = Object.defineProperty;
var G = (o, e, t) => e in o ? W(o, e, { enumerable: !0, configurable: !0, writable: !0, value: t }) : o[e] = t;
var D = (o, e, t) => G(o, typeof e != "symbol" ? e + "" : e, t);
import { ref as M, defineComponent as w, openBlock as l, createElementBlock as p, Fragment as L, renderSlot as x, watch as J, createElementVNode as a, onMounted as V, nextTick as O, createVNode as b, createSlots as U, withCtx as Q, unref as i, createBlock as m, createCommentVNode as k, getCurrentInstance as F, normalizeProps as K, mergeProps as N, normalizeClass as P, createTextVNode as X, toDisplayString as q, withDirectives as T, vShow as I, computed as Y } from "vue";
import { createHighlighter as ee } from "shiki";
const y = class y {
  constructor() {
    D(this, "domContentLoadedRegex");
    this.domContentLoadedRegex = /document\.addEventListener\s*\(\s*['"]DOMContentLoaded['"]\s*,\s*(function\s*\([^)]*\)\s*\{|\([^)]*\)\s*=>\s*\{)([\s\S]*?(\{[\s\S]*?\}[\s\S]*?)*)\}\s*\);?\s*|document\.addEventListener\s*\(\s*['"]DOMContentLoaded['"]\s*,\s*(\w+)\s*\);?\s*/;
  }
  /**
   * Returns the singleton instance of PreviewScriptManager.
   */
  static getInstance() {
    return y.instance || (y.instance = new y()), y.instance;
  }
  /**
   * Initializes the observer and executes scripts within the initial content.
   */
  executeScriptsTick() {
    const e = document.querySelector(
      ".preview-content"
    );
    e && (new MutationObserver(
      (n) => this.handleMutations(n)
    ).observe(e, { childList: !0, subtree: !0 }), this.executeScripts(e));
  }
  /**
   * Handles mutations and triggers script execution for added nodes.
   */
  handleMutations(e) {
    e.forEach((t) => {
      t.type === "childList" && this.executeScripts(t.target);
    });
  }
  /**
   * Executes all script elements within the provided container.
   * @param {HTMLElement} container - The container element to search for script elements.
   */
  executeScripts(e) {
    e.querySelectorAll("script").forEach((n) => {
      n.getAttribute("data-executed") || (n.textContent && this.processAndExecuteScript(n.textContent), n.setAttribute("data-executed", "true"));
    });
  }
  /**
   * Processes and executes the provided script content.
   * @param {string} scriptContent - The script content to be processed and executed.
   */
  processAndExecuteScript(e) {
    const t = this.domContentLoadedRegex.exec(e);
    if (t) {
      const n = e.replace(t[0], "").trim();
      if (n && this.createAndExecuteScript(n), t[2]) {
        const s = t[2].trim();
        this.createAndExecuteScript(
          `(function() { ${s} })();`
        );
      } else if (t[4]) {
        const s = t[4].trim();
        this.createAndExecuteScript(`${s}();`);
      }
    } else
      this.createAndExecuteScript(e);
  }
  /**
   * Creates a new script element with the provided content and executes it.
   * @param {string} scriptContent - The script content to be executed.
   */
  createAndExecuteScript(e) {
    var n;
    const t = document.createElement("script");
    t.setAttribute("data-executed", "true"), t.textContent = e, (n = document.body.appendChild(t).parentNode) == null || n.removeChild(t);
  }
};
D(y, "instance");
let S = y;
function E() {
  const o = M("");
  async function e(t, n) {
    const s = await ee({
      langs: [],
      themes: Object.values(n)
    });
    await s.loadLanguage("templ"), o.value = s.codeToHtml(t, {
      lang: "templ",
      themes: n,
      defaultColor: !1
    });
  }
  return {
    highlightedCode: o,
    highlightCode: e
  };
}
const te = /* @__PURE__ */ w({
  __name: "ConditionalWrapper",
  props: {
    isPreviewFirst: { type: Boolean }
  },
  setup(o) {
    const e = o;
    return (t, n) => (l(), p("div", null, [
      e.isPreviewFirst ? (l(), p(L, { key: 0 }, [
        x(t.$slots, "preview"),
        x(t.$slots, "code")
      ], 64)) : (l(), p(L, { key: 1 }, [
        x(t.$slots, "code"),
        x(t.$slots, "preview")
      ], 64))
    ]));
  }
}), ne = ["innerHTML"], oe = /* @__PURE__ */ w({
  __name: "ComponentPreviewer",
  props: {
    content: {}
  },
  setup(o) {
    const e = o;
    return (t, n) => (l(), p("div", {
      class: "preview-content",
      innerHTML: e.content
    }, null, 8, ne));
  }
}), $ = (o, e) => {
  const t = o.__vccOpts || o;
  for (const [n, s] of e)
    t[n] = s;
  return t;
}, z = /* @__PURE__ */ $(oe, [["__scopeId", "data-v-67f64b47"]]), se = { class: "code-content" }, ie = { class: "language-templ vp-adaptive-theme" }, ae = ["innerHTML"], le = /* @__PURE__ */ w({
  __name: "ComponentCoder",
  props: {
    content: {}
  },
  setup(o) {
    const e = o, t = M(e.content);
    return J(
      () => e.content,
      (n) => {
        t.value = n;
      }
    ), (n, s) => (l(), p("div", se, [
      a("div", ie, [
        s[0] || (s[0] = a("button", {
          title: "Copy Code",
          class: "copy"
        }, null, -1)),
        s[1] || (s[1] = a("span", { class: "lang" }, "templ", -1)),
        a("span", {
          class: "vp-code",
          innerHTML: t.value
        }, null, 8, ae)
      ])
    ]));
  }
}), A = /* @__PURE__ */ $(le, [["__scopeId", "data-v-fb5c439d"]]), ce = { class: "container" }, re = /* @__PURE__ */ w({
  __name: "VTPCard",
  props: {
    codeContent: {},
    htmlContent: {},
    themes: {},
    buttonStyle: {},
    isPreviewFirst: { type: Boolean },
    isPreviewOnly: { type: Boolean }
  },
  setup(o) {
    const e = o, t = H(e.htmlContent), { highlightedCode: n, highlightCode: s } = E(), c = S.getInstance();
    return V(async () => {
      await s(e.codeContent, e.themes), O(() => {
        c.executeScriptsTick();
      });
    }), (r, v) => (l(), p("div", ce, [
      b(te, {
        "is-preview-first": e.isPreviewFirst
      }, U({
        preview: Q(() => [
          b(z, { content: i(t) }, null, 8, ["content"])
        ]),
        _: 2
      }, [
        e.isPreviewOnly ? void 0 : {
          name: "code",
          fn: Q(() => [
            i(n) ? (l(), m(A, {
              key: 0,
              content: i(n)
            }, null, 8, ["content"])) : k("", !0)
          ]),
          key: "0"
        }
      ]), 1032, ["is-preview-first"])
    ]));
  }
}), Z = /* @__PURE__ */ $(re, [["__scopeId", "data-v-f8f9c09b"]]), de = ["width", "height", "fill"], j = /* @__PURE__ */ w({
  __name: "CodeIcon",
  props: {
    fill: {},
    size: { default: 16 }
  },
  setup(o) {
    const e = o;
    return (t, n) => (l(), p("svg", {
      xmlns: "http://www.w3.org/2000/svg",
      width: e.size,
      height: e.size,
      viewBox: "0 0 16 16",
      fill: e.fill,
      "aria-hidden": "true"
    }, n[0] || (n[0] = [
      a("path", {
        "fill-rule": "evenodd",
        d: "M4.78 4.97a.75.75 0 0 1 0 1.06L2.81 8l1.97 1.97a.75.75 0 1 1-1.06 1.06l-2.5-2.5a.75.75 0 0 1 0-1.06l2.5-2.5a.75.75 0 0 1 1.06 0ZM11.22 4.97a.75.75 0 0 0 0 1.06L13.19 8l-1.97 1.97a.75.75 0 1 0 1.06 1.06l2.5-2.5a.75.75 0 0 0 0-1.06l-2.5-2.5a.75.75 0 0 0-1.06 0ZM8.856 2.008a.75.75 0 0 1 .636.848l-1.5 10.5a.75.75 0 0 1-1.484-.212l1.5-10.5a.75.75 0 0 1 .848-.636Z",
        "clip-rule": "evenodd"
      }, null, -1)
    ]), 8, de));
  }
}), ue = {
  key: 1,
  class: "container"
}, pe = { class: "code-section" }, ve = ["aria-controls"], he = /* @__PURE__ */ w({
  __name: "VTPCodeToggle",
  props: {
    codeContent: {},
    htmlContent: {},
    themes: {},
    buttonStyle: {},
    isPreviewFirst: { type: Boolean },
    isPreviewOnly: { type: Boolean }
  },
  setup(o) {
    const e = o, t = M(!1), n = H(e.htmlContent), s = S.getInstance(), { highlightedCode: c, highlightCode: r } = E(), v = F(), d = v ? v.uid.toString() : Math.random().toString(36).substring(2, 11);
    function g() {
      t.value = !t.value;
    }
    return V(async () => {
      await r(e.codeContent, e.themes), O(() => {
        s.executeScriptsTick();
      });
    }), (_, u) => e.isPreviewOnly ? (l(), m(Z, K(N({ key: 0 }, e)), null, 16)) : (l(), p("div", ue, [
      b(z, { content: i(n) }, null, 8, ["content"]),
      a("div", pe, [
        a("button", {
          class: P(`button-${e.buttonStyle}`),
          "aria-controls": "code-content-" + i(d),
          "aria-label": "view the source code",
          onClick: g
        }, [
          x(_.$slots, "code-icon", {}, () => [
            b(j, {
              fill: `var(--vp-button-${e.buttonStyle}-text)`
            }, null, 8, ["fill"])
          ], !0),
          X(" " + q(t.value ? "Hide Code" : "Show Code"), 1)
        ], 10, ve),
        i(c) && t.value ? (l(), m(A, {
          key: 0,
          id: "code-content-" + i(d),
          content: i(c),
          "aria-hidden": !t.value
        }, null, 8, ["id", "content", "aria-hidden"])) : k("", !0)
      ])
    ]));
  }
}), Ae = /* @__PURE__ */ $(he, [["__scopeId", "data-v-18b96c31"]]), we = { class: "wrapper" }, ge = {
  class: "tabs",
  role: "tablist"
}, be = ["id", "aria-selected", "aria-controls"], me = ["id", "aria-selected", "aria-controls"], _e = ["id"], Ce = /* @__PURE__ */ w({
  __name: "VTPTabs",
  props: {
    codeContent: {},
    htmlContent: {},
    themes: {},
    buttonStyle: {},
    isPreviewFirst: { type: Boolean },
    isPreviewOnly: { type: Boolean }
  },
  setup(o) {
    const e = o, t = H(e.htmlContent), { highlightedCode: n, highlightCode: s } = E(), c = S.getInstance(), r = M("preview"), v = F(), d = v ? v.uid.toString() : Math.random().toString(36).substring(2, 11), g = (_, u) => {
      (_.key === "Enter" || _.key === " ") && (r.value = u);
    };
    return V(async () => {
      await s(e.codeContent, e.themes), O(() => {
        c.executeScriptsTick();
      });
    }), (_, u) => e.isPreviewOnly ? (l(), m(Z, K(N({ key: 0 }, e)), null, 16)) : (l(), p(L, { key: 1 }, [
      a("div", we, [
        a("div", ge, [
          a("button", {
            id: "tab-preview-" + i(d),
            role: "tab",
            "aria-selected": r.value === "preview",
            class: P({ active: r.value === "preview" }),
            tabindex: "0",
            "aria-controls": "tabpanel-preview-" + i(d),
            "aria-label": "preview the component",
            onClick: u[0] || (u[0] = (C) => r.value = "preview"),
            onKeydown: u[1] || (u[1] = (C) => g(C, "preview"))
          }, " Preview ", 42, be),
          a("button", {
            id: "tab-code-" + i(d),
            role: "tab",
            "aria-selected": r.value === "code",
            class: P({ active: r.value === "code" }),
            tabindex: "0",
            "aria-controls": "tabpanel-code-" + i(d),
            "aria-label": "view the source code",
            onClick: u[2] || (u[2] = (C) => r.value = "code"),
            onKeydown: u[3] || (u[3] = (C) => g(C, "code"))
          }, " Code ", 42, me)
        ])
      ]),
      a("div", {
        id: "tabpanel-" + r.value + "-" + i(d),
        class: "tab-content",
        role: "tabpanel"
      }, [
        T(b(z, { content: i(t) }, null, 8, ["content"]), [
          [I, r.value === "preview"]
        ]),
        i(n) ? T((l(), m(A, {
          key: 0,
          content: i(n)
        }, null, 8, ["content"])), [
          [I, r.value === "code"]
        ]) : k("", !0)
      ], 8, _e)
    ], 64));
  }
}), He = /* @__PURE__ */ $(Ce, [["__scopeId", "data-v-79921428"]]), fe = ["width", "height", "fill"], ye = /* @__PURE__ */ w({
  __name: "ViewIcon",
  props: {
    fill: {},
    size: { default: 16 }
  },
  setup(o) {
    const e = o;
    return (t, n) => (l(), p("svg", {
      xmlns: "http://www.w3.org/2000/svg",
      width: e.size,
      height: e.size,
      viewBox: "0 0 16 16",
      fill: e.fill,
      "aria-hidden": "true"
    }, n[0] || (n[0] = [
      a("path", { d: "M8 9.5a1.5 1.5 0 1 0 0-3 1.5 1.5 0 0 0 0 3Z" }, null, -1),
      a("path", {
        "fill-rule": "evenodd",
        d: "M1.38 8.28a.87.87 0 0 1 0-.566 7.003 7.003 0 0 1 13.238.006.87.87 0 0 1 0 .566A7.003 7.003 0 0 1 1.379 8.28ZM11 8a3 3 0 1 1-6 0 3 3 0 0 1 6 0Z",
        "clip-rule": "evenodd"
      }, null, -1)
    ]), 8, fe));
  }
}), xe = { class: "wrapper" }, Se = {
  class: "tabs",
  role: "tablist"
}, $e = ["id", "aria-selected", "aria-controls"], ke = ["id", "aria-selected", "aria-controls"], Pe = ["id"], Te = /* @__PURE__ */ w({
  __name: "VTPIconTabs",
  props: {
    codeContent: {},
    htmlContent: {},
    themes: {},
    buttonStyle: {},
    isPreviewFirst: { type: Boolean },
    isPreviewOnly: { type: Boolean }
  },
  setup(o) {
    const e = o, t = H(e.htmlContent), n = S.getInstance(), s = M("preview"), { highlightedCode: c, highlightCode: r } = E(), v = F(), d = v ? v.uid.toString() : Math.random().toString(36).substring(2, 11), g = (f) => Y(() => s.value === f ? "var(--vp-button-brand-text)" : "var(--vp-button-alt-text)"), _ = g("preview"), u = g("code"), C = (f, h) => {
      (f.key === "Enter" || f.key === " ") && (s.value = h);
    };
    return V(async () => {
      await r(e.codeContent, e.themes), O(() => {
        n.executeScriptsTick();
      });
    }), (f, h) => e.isPreviewOnly ? (l(), m(Z, K(N({ key: 0 }, e)), null, 16)) : (l(), p(L, { key: 1 }, [
      a("div", xe, [
        a("div", Se, [
          a("button", {
            id: "tab-preview-" + i(d),
            role: "tab",
            "aria-selected": s.value === "preview",
            class: P({ active: s.value === "preview" }),
            tabindex: "0",
            "aria-controls": "tabpanel-preview-" + i(d),
            "aria-label": "preview the component",
            onClick: h[0] || (h[0] = (B) => s.value = "preview"),
            onKeydown: h[1] || (h[1] = (B) => C(B, "preview"))
          }, [
            x(f.$slots, "preview-icon", {}, () => [
              b(ye, { fill: i(_) }, null, 8, ["fill"])
            ], !0)
          ], 42, $e),
          a("button", {
            id: "tab-code-" + i(d),
            role: "tab",
            "aria-selected": s.value === "code",
            class: P({ active: s.value === "code" }),
            tabindex: "0",
            "aria-controls": "tabpanel-code-" + i(d),
            "aria-label": "view the source code",
            onClick: h[2] || (h[2] = (B) => s.value = "code"),
            onKeydown: h[3] || (h[3] = (B) => C(B, "code"))
          }, [
            x(f.$slots, "code-icon", {}, () => [
              b(j, { fill: i(u) }, null, 8, ["fill"])
            ], !0)
          ], 42, ke)
        ])
      ]),
      a("div", {
        id: "tabpanel-" + s.value + "-" + i(d),
        class: "tab-content",
        role: "tabpanel"
      }, [
        T(b(z, { content: i(t) }, null, 8, ["content"]), [
          [I, s.value === "preview"]
        ]),
        i(c) ? T((l(), m(A, {
          key: 0,
          content: i(c)
        }, null, 8, ["content"])), [
          [I, s.value === "code"]
        ]) : k("", !0)
      ], 8, Pe)
    ], 64));
  }
}), Fe = /* @__PURE__ */ $(Te, [["__scopeId", "data-v-4b396293"]]), Ie = { class: "wrapper" }, Me = {
  class: "tabs",
  role: "tablist"
}, Be = {
  key: 0,
  class: "toggle-label"
}, Le = ["id"], Ve = /* @__PURE__ */ w({
  __name: "VTPToggle",
  props: {
    modelValue: { type: Boolean, default: !1 },
    label: { default: "view the code" },
    showLabel: { type: Boolean, default: !0 },
    activeColor: { default: "var(--vp-button-brand-bg)" },
    codeContent: {},
    htmlContent: {},
    themes: {},
    buttonStyle: {},
    isPreviewFirst: { type: Boolean },
    isPreviewOnly: { type: Boolean }
  },
  setup(o) {
    const e = o, t = M("preview"), n = H(e.htmlContent), s = S.getInstance(), { highlightedCode: c, highlightCode: r } = E(), v = F(), d = v ? v.uid.toString() : Math.random().toString(36).substring(2, 11), g = () => {
      t.value = t.value === "preview" ? "code" : "preview";
    };
    return V(async () => {
      await r(e.codeContent, e.themes), O(() => {
        s.executeScriptsTick();
      });
    }), (_, u) => e.isPreviewOnly ? (l(), m(Z, K(N({ key: 0 }, e)), null, 16)) : (l(), p(L, { key: 1 }, [
      a("div", Ie, [
        a("div", Me, [
          a("div", {
            class: P(["toggle-container", { "is-checked": t.value === "code" }]),
            onClick: g
          }, [
            e.showLabel ? (l(), p("span", Be, q(e.label), 1)) : k("", !0),
            u[0] || (u[0] = a("div", { class: "toggle-switch" }, null, -1))
          ], 2)
        ])
      ]),
      a("div", {
        id: "tabpanel-" + t.value + "-" + i(d),
        class: "tab-content",
        role: "tabpanel"
      }, [
        T(b(z, { content: i(n) }, null, 8, ["content"]), [
          [I, t.value === "preview"]
        ]),
        i(c) ? T((l(), m(A, {
          key: 0,
          content: i(c)
        }, null, 8, ["content"])), [
          [I, t.value === "code"]
        ]) : k("", !0)
      ], 8, Le)
    ], 64));
  }
}), Ke = /* @__PURE__ */ $(Ve, [["__scopeId", "data-v-3e85d21b"]]);
function H(o) {
  let e = "", t = !1, n = !1;
  for (let s = 0; s < o.length; s++) {
    const c = o[s];
    c === '"' && !n ? t ? (R(e) ? e += '"' : e += "'", t = !1) : (R(e) ? e += '"' : e += "'", t = !0) : (c === "'" && !t && (n = !n), e += c);
  }
  return e;
}
function R(o) {
  const e = o.lastIndexOf("["), t = o.lastIndexOf("]");
  return e > t;
}
export {
  Z as VTPCard,
  Ae as VTPCodeToggle,
  Fe as VTPIconTabs,
  He as VTPTabs,
  Ke as VTPToggle,
  H as normalizeQuotes
};
