import { MarkdownRenderer } from 'vitepress';
import { PluginContext } from '../types';
export declare class MarkdownProcessor {
    private renderer;
    private context;
    private TEMPL_DEMO_REGEX;
    constructor(renderer: MarkdownRenderer, context: PluginContext);
    /**
     * Transforms Markdown content if it contains templ-demo.
     */
    transform(code: string, id: string): {
        code: string;
        map: null;
    } | undefined;
}
