/**
 * Checks if the required binaries are installed on the system.
 * @param binaries - The list of binaries to check.
 */
export declare function checkBinaries(binaries: string[]): void;
/**
 * Executes a command synchronously.
 * @param command - The command string to execute.
 */
export declare function executeCommandSync(command: string): void;
